function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect } from 'react';
import { Select } from 'antd';
import { throttle } from 'lodash';
import net from "../services";
export default function selectSearch(_ref) {
  var api = _ref.api,
    initApi = _ref.initApi,
    onChange = _ref.onChange,
    value = _ref.value,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled;
  var timeout;
  var _useState = useState(true),
    _useState2 = _slicedToArray(_useState, 2),
    initValue = _useState2[0],
    setInitValue = _useState2[1];
  var _useState3 = useState([]),
    _useState4 = _slicedToArray(_useState3, 2),
    selectListValue = _useState4[0],
    setSelectListValue = _useState4[1];
  var _useState5 = useState(value),
    _useState6 = _slicedToArray(_useState5, 2),
    defaultValue = _useState6[0],
    setdefaultVlaue = _useState6[1];
  useEffect(function () {
    if (initValue && initApi && value) {
      net.request("".concat(initApi, "?id=").concat(value), {
        method: 'get'
      }).then(function (data) {
        var _data$data, _dataSource$;
        var dataSource = (data === null || data === void 0 || (_data$data = data.data) === null || _data$data === void 0 ? void 0 : _data$data.dataSource) || [];
        // setdefaultVlaue(dataSource[0]?.label);
        setSelectListValue(dataSource);
        setdefaultVlaue((_dataSource$ = dataSource[0]) === null || _dataSource$ === void 0 ? void 0 : _dataSource$.label);
        setInitValue(false);
      });
    } else {
      setdefaultVlaue(value);
    }
  }, [value]);
  var fetch = function fetch(val) {
    if (timeout) {
      clearTimeout(timeout);
      timeout = null;
    }
    var request = function request() {
      net.request(api, {
        method: 'POST',
        data: {
          search: {
            keyword: val
          }
        }
      }).then(function (data) {
        var _data$data2;
        var dataSource = data === null || data === void 0 || (_data$data2 = data.data) === null || _data$data2 === void 0 ? void 0 : _data$data2.dataSource;
        setSelectListValue(dataSource);
      });
    };
    timeout = setTimeout(request, 300);
  };
  var onChangeValue = function onChangeValue(e) {
    // console.log(e, 'eee');
    onChange(e);
  };
  var handleSearch = throttle(function (val) {
    if (val) {
      fetch(val);
    }
  }, 200, {
    trailing: false
  });
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Select, {
    showSearch: true,
    placeholder: "\u8BF7\u641C\u7D22",
    showArrow: false
    // optionFilterProp="children"
    ,
    onChange: onChangeValue,
    onSearch: handleSearch,
    options: selectListValue,
    optionFilterProp: "label",
    value: defaultValue,
    disabled: disabled
  }));
}